      PROGRAM Pythia
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Standard PYTHIA commonblocks.
      INTEGER N,NPAD,K
      REAL*8 P,V
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL*8 PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER MDCY,MDME,KFDP
      REAL*8 BRAT
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      INTEGER MSEL,MSELPD,MSUB,KFIN
      REAL*8 CKIN
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      INTEGER MSTP,MSTI
      REAL*8 PARP,PARI
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      character*80 resfile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C   For jet clustering,
      parameter( npmax= 2000 )
      double precision ppart(4,npmax)
      parameter( Rcone= 0.4d0 )
      parameter( palg = -1.d0 )   ! anti-kt
      parameter( ghost_maxrap= 6.0d0, ghost_area = 0.01d0 )
      parameter( nrepeat= 1 )
      double precision pjets(4,npmax)

      parameter( njdmax= 100 )
      double precision plep(4),pneu(4),ptjord(njdmax)
      integer ipjord(njdmax)

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events. 
C-----------------------------------------------------------------------
      NEV = 1000000                 ! Number of events

C  Output result file.
C      lunres= 0
      lunres= 20

      if( lunres.gt.0 ) then
         resfile= 'result.dat'
         open(lunres,file=resfile,form='UNFORMATTED',status='NEW')
      endif
C-----------------------------------------------------------------------
C  PS/MI choice in Pythia.
C-----------------------------------------------------------------------
C      MSTP(61)  = 0   ! no ISR
C      MSTP(71)  = 0   ! no FSR
C      MSTP(81)  = 0   ! no MI, old PS when PYEVNT called
C      MSTP(81)  = 1   ! MI on, old PS when PYEVNT called (default)
C      MSTP(81)  = 20  ! no MI, new PS (= PYEVNW)
C      MSTP(81)  = 21  ! MI on, new PS (= PYEVNW)
C      MSTP(111) = 0   ! no hadronization
C-----------------------------------------------------------------------
C  Reset the energy-scale factor
C-----------------------------------------------------------------------
C  The default value of PARP(67) for the "old" PS is not suitable.
C  Comment out when the "new" PS is chosen.
      PARP(67)= 1.0    ! ISR energy scale factor for the "old" PS.
      PARP(71)= 1.0    ! FSR energy scale factor.
C-----------------------------------------------------------------------
C   PDF choice
C-----------------------------------------------------------------------
C      mstp(51)= 1         ! CTEQ3L
C      mstp(51)= 4         ! GRV 94L
C      mstp(51)= 7         ! CTEQ5L (default)
C      mstp(51)= 11        ! GRV 92L
C      mstp(51)= 12        ! EHLQ set 1
C      mstp(58)= 5         ! Nr. of flavor in PDF 
C-----------------------------------------------------------------------
C  Initialization
C-----------------------------------------------------------------------
C  UPINIT is called in PYINIT.
      CALL PYINIT('USER',' ',' ',0,0d0)
C-----------------------------------------------------------------------
C  Print out the parameters
C-----------------------------------------------------------------------
C  Basic control
      print *,'PS, multiple-interaction, hadronization:'
      print *,'  mstp(61, 71, 81, 111) =',mstp(61),mstp(71),
     >     mstp(81),mstp(111)
      print *,'PDF choice: mstp(51) =',mstp(51),
     >     ' with NF: mstp(58) =',mstp(58)

C  Energy scale factors
      print *,'Energy scale factors:'
      print '(5X,''parp(67), parp(71) ='',2F10.3)', parp(67),parp(71)

C  Multiple interaction
      print *,'Multiple interaction model: mstp(82) = ',mstp(82)
      print '(5X,''parp(82) ='',F10.3)', parp(82)
      print '(5X,''parp(83), parp(84) ='',2F10.3)', parp(83),parp(84)
      print '(5X,''parp(85), parp(86) ='',2F10.3)', parp(85),parp(86)
      print '(5X,''parp(89), parp(90) ='',2F10.3)', parp(89),parp(90)

C  Primordial kT
      print *,'Primordial kT mode: mstp(91) = ',mstp(91)
      print '(5X,''parp(91), parp(93) = '',2F10.3)',parp(91),parp(93)

C...Book histograms.
      call hlimit(lhcom)

      call hbook1(1,'mass of V$',100,0.,200.,0.)
      call hbook1(2,'pt of V$',100,0.,200.,0.)
      call hbook1(3,'rapidity of V$',100,-10.,10.,0.)
      call hbook1(4,'rapidity of W+$',100,-10.,10.,0.)
      call hbook1(5,'rapidity of W-$',100,-10.,10.,0.)

      call hbook1(11,'mass of V (pos)$',100,0.,200.,0.)
      call hbook1(12,'pt of V (pos)$',100,0.,200.,0.)
      call hbook1(13,'rapidity of V (pos)$',100,-10.,10.,0.)
      call hbook1(14,'mass of V (neg)$',100,0.,200.,0.)
      call hbook1(15,'pt of V (neg)$',100,0.,200.,0.)
      call hbook1(16,'rapidity of V (neg)$',100,-10.,10.,0.)

      call hbook1(20,'pt of lepton$',100,0.,100.,0.)
      call hbook1(21,'eta of lepton$',100,-10.,10.,0.)
      call hbook1(22,'pt of l+$',100,0.,100.,0.)
      call hbook1(23,'eta of l+$',100,-10.,10.,0.)
      call hbook1(24,'pt of l-$',100,0.,100.,0.)
      call hbook1(25,'eta of l-$',100,-10.,10.,0.)
      call hbook1(26,'pt of neutrino$',100,0.,100.,0.)
      call hbook1(27,'mt (GeV)$',100,0.,200.,0.)

      call hbook1(30,'num. of particles$',100,0.,2000.,0.)
      call hbook1(31,'num. of jets$',100,0.,500.,0.)
      call hbook1(32,'pt of jet (GeV)$',100,0.,500.,0.)
      call hbook1(33,'eta of jet$',100,-5.,5.,0.)
      call hbook1(34,'Delta-R of jet to lep$',100,0.,5.,0.)

      call hbook1(40,'num. of detected jets$',50,0.,50.,0.)
      call hbook1(41,'num. of detected jets (w0j)$',50,0.,50.,0.)
      call hbook1(42,'num. of detected jets (w1j)$',50,0.,50.,0.)
      call hbook1(43,'num. of detected jets (w2j)$',50,0.,50.,0.)
      call hbook1(44,'pt of detected jets (GeV)$',100,0.,500.,0.)
      call hbook1(45,'eta of detected jets$',100,-5.,5.,0.)
      call hbook1(46,'Delta-R of detected jets to lep$',100,0.,5.,0.)
      call hbook1(47,'mass of detected jets$',100,0.,50.,0.)

      call hbook1(50,'pt of 1st jet$',100,0.,500.,0.)
      call hbook1(51,'eta of 1st jet$',40,-10.,10.,0.)
      call hbook1(52,'pt of 1st jet (w0j)$',100,0.,500.,0.)
      call hbook1(53,'pt of 1st jet (w1j)$',100,0.,500.,0.)
      call hbook1(54,'pt of 1st jet (w2j)$',100,0.,500.,0.)

      call hbook1(60,'pt of 2nd jet$',100,0.,500.,0.)
      call hbook1(61,'eta of 2nd jet$',40,-10.,10.,0.)
      call hbook1(62,'pt of 2nd jet (w0j)$',100,0.,500.,0.)
      call hbook1(63,'pt of 2nd jet (w1j)$',100,0.,500.,0.)
      call hbook1(64,'pt of 2nd jet (w2j)$',100,0.,500.,0.)

      call hbook1(70,'pt of 3rd jet$',100,0.,500.,0.)
      call hbook1(71,'eta of 3rd jet$',40,-10.,10.,0.)
      call hbook1(72,'pt of 3rd jet (w0j)$',100,0.,500.,0.)
      call hbook1(73,'pt of 3rd jet (w1j)$',100,0.,500.,0.)
      call hbook1(74,'pt of 3rd jet (w2j)$',100,0.,500.,0.)

      call hbook1(80,'pt of V$',50,0.,500.,0.)
      call hbook1(81,'rapidity of V$',40,-10.,10.,0.)
      call hbook1(82,'pt of V (w0j)$',50,0.,500.,0.)
      call hbook1(83,'pt of V (w1j)$',50,0.,500.,0.)
      call hbook1(84,'pt of V (w2j)$',50,0.,500.,0.)

      call hbook1(100,'Num. of particles$',100,0.,100.,0.)
      call hbook1(101,'Num. of ISR jets$',100,0.,100.,0.)
      call hbook1(102,'Num. of FSR jets$',100,0.,100.,0.)
C-----------------------------------------------------------------------
C  Integrated absolute cross section.
      xabs= 0.d0
      do i=1,NPRUP
         xabs= xabs +XSECUP(i)
      enddo

      evpos= 0.d0
      evneg= 0.d0
      evrespos= 0.d0
      evresneg= 0.d0

C...Event loop.
      DO IEV = 1,NEV

C  Event processing.
C  UPEVNT is called in PYEVNT; then, the PS and decay simulations are done 
C  according the parameter choice.
         CALL PYEVNT
         if( MSTI(51).ne.0 ) then
            print *,'MSTI(51) = ',MSTI(51)
            print *,'-> EOD signal from PYEVNT'
            goto 9000
         endif

         if( IEV.le.1 ) then
            print *,''
            print *,'Event# ',IEV
            CALL PYLIST(1)
         elseif( ( IEV.lt.1000 .and. mod(IEV,100).eq.0 )
     >           .or. ( IEV.lt.10000 .and. mod(IEV,1000).eq.0 )
     >           .or. mod(IEV,10000).eq.0 ) then
            print *,'Event# ',IEV
         endif

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

C  Analysis
C  (input data)
         nisr= 0
         nfsr= 0
         do i=1,NUP
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).le.2 .and. 
     >           MOTHUP(2,i).eq.0 ) nisr= nisr +1
            if( ISTUP(i).eq.1 .and. MOTHUP(1,i).eq.1 .and. 
     >           MOTHUP(2,i).eq.2 ) nfsr= nfsr +1
         enddo
         call hf1(100,NUP+.5,1.)
         call hf1(101,nisr+.5,1.)
         call hf1(102,nfsr+.5,1.)

C  (after PYTHIA)
C   Number of records for documentation
         do i=1,n
            if( K(i,1).ne.21 ) then
               ndoc= i -1
               goto 1
            endif
         enddo
 1       continue

C   Search the W boson and leptons in the documentation.
         ipvec0= 0
         iplep0= 0
         ipneu0= 0
         do i=1,ndoc
            idabs= iabs( K(i,2) )
            if( idabs.eq.24 ) then
               ipvec0= i
            elseif( idabs.eq.11 .or. idabs.eq.13 ) then
               iplep0= i
            elseif( idabs.eq.12 .or. idabs.eq.14 ) then
               ipneu0= i
            endif
         enddo
         if( ipvec0.lt.1 ) then
            print *,'No vector boson in the documentation.'
            stop
         endif

C   Search the W boson and leptons in the real record.
         ipvec= 0
         iplep= iplep0
         ipneu= ipneu0
         do i=ndoc+1,n
            idabs= iabs( K(i,2) )
            imoth= K(i,3)
            if( idabs.eq.24 ) then
               ipvec= i
            endif
            if( idabs.eq.11 .or. idabs.eq.13 ) then
               if( imoth.eq.iplep ) iplep= i
            endif
            if( idabs.eq.12 .or. idabs.eq.14 ) then
               if( imoth.eq.ipneu .or. imoth.eq.0 ) ipneu= i
            endif
         enddo
         if( ipvec.lt.1 ) then
            print *,'No vector boson in the real record.'
            CALL PYLIST(1)
            stop
         endif

C  Properties of W.
         amvec= PYP( ipvec, 5 )
         ptvec= PYP( ipvec, 10 )
         rapvec= PYP( ipvec, 17 )
         call hf1(1,real(amvec),weight)
         call hf1(2,real(ptvec),weight)
         call hf1(3,real(rapvec),weight)
         if( K(ipvec,2).gt.0 ) then
            call hf1(4,real(rapvec),weight)
         else
            call hf1(5,real(rapvec),weight)
         endif

         if( weight.ge.0. ) then
            call hf1(11,real(amvec),1.)
            call hf1(12,real(ptvec),1.)
            call hf1(13,real(rapvec),1.)
         else
            call hf1(14,real(amvec),1.)
            call hf1(15,real(ptvec),1.)
            call hf1(16,real(rapvec),1.)
         endif

C  Decay leptons.
         ipl= 0
         ipn= 0
         if( iplep.gt.0 .and. ipneu.gt.0 ) then
C            ipl= iplep
C            ipn= ipneu
C  Born-level definition according to the ATLAS result.
            ipl= iplep0
            ipn= ipneu0
            idlep= K(ipl,2)
            ptlep= PYP( ipl, 10 )
            etalep= PYP( ipl, 19 )
            ptneu= PYP( ipn, 10 )
            amt2= 2.d0*( ptlep*ptneu
     >           -P(ipl,1)*P(ipn,1) -P(ipl,2)*P(ipn,2) )
            amt= 0.d0
            if( amt2.gt.0.d0 ) amt= sqrt( amt2 )
            call hf1(20,real(ptlep),weight)
            call hf1(21,real(etalep),weight)
            if( idlep.lt.0 ) then
               call hf1(22,real(ptlep),weight)
               call hf1(23,real(etalep),weight)
            else
               call hf1(24,real(ptlep),weight)
               call hf1(25,real(etalep),weight)
            endif
            call hf1(26,real(ptneu),weight)
            call hf1(27,real(amt),weight)
         endif

C  Event selection.
         if( ipl.lt.1 .or. ipn.lt.1 ) goto 9
         if( ptlep.lt.20.d0 ) goto 9
         if( abs( etalep ).gt.2.5d0 ) goto 9
         if( ptneu.lt.25.d0 ) goto 9
         if( amt.lt.40.d0 ) goto 9

C   Jet reconstruction.
         ipl1= ipl
         idl= K(ipl,2)
         npart= 0
         do i=ndoc+1,n
            if( K(i,3).eq.ipl1 ) then
               if( K(i,2).eq.idl ) ipl1= i
            else
               if( K(i,1).eq.1 ) then
                  idabs= iabs( K(i,2) )
                  if( idabs.eq.12 .or. idabs.eq.14 
     >                 .or. idabs.eq.16 ) then
                  else
                     pt= PYP(i,10)
                     eta= PYP(i,19)
C                     if( pt.gt.0.1d0 .and. abs(eta).lt.5.0d0 ) then
                     if( abs(eta).lt.5.0d0 ) then
                        npart= npart +1
                        if( npart.le.npmax ) then
                           do j=1,4
                              ppart(j,npart)= P(i,j)
                           enddo
                        endif
                     endif
                  endif
               endif
            endif
         enddo
         call hf1(30,npart+.5,weight)
         if( npart.gt.npmax ) npart= npmax

C   Anti-kt clustering by FastJet.
         call fastjetppgenktwitharea(ppart,npart,Rcone,palg,
     >        ghost_maxrap,nrepeat,ghost_area, pjets,njet)
         call hf1(31,njet+.5,weight)

         do j=1,4
            plep(j)= P(ipl,j)
            pneu(j)= P(ipn,j)
         enddo
         do i=1,njdmax
            ipjord(i)= 0
            ptjord(i)= 0.d0
         enddo
         njdet= 0
         do i=1,njet
            call pteta( pjets(1,i), pt, eta )
            drlj= delta_r( plep, pjets(1,i) )
            call hf1(32,real(pt),weight)
            call hf1(33,real(eta),weight)
            call hf1(34,real(drlj),weight)
C   Jet acceptance.
            if( pt.ge.20.d0 .and. abs( eta ).lt.4.4d0 
     >           .and. drlj.gt.0.5d0 ) then
               njdet= njdet +1
               if( njdet.le.njdmax ) then
                  if( njdet.eq.1 ) then
                     ipjord(1)= i
                     ptjord(1)= pt
                  else
                     do iord=njdet-1,1,-1
                        if( pt.le.ptjord(iord) ) then
                           ipjord(iord+1)= i
                           ptjord(iord+1)= pt
                           goto 4
                        else
                           ipjord(iord+1)= ipjord(iord)
                           ptjord(iord+1)= ptjord(iord)
                        endif
                     enddo
                  endif
 4                continue
               endif
            endif
         enddo
         call hf1(40,njdet+.5,weight)
         if( IDPRUP.eq.100 ) then
            call hf1(41,njdet+.5,weight)
         elseif( IDPRUP.eq.101 ) then
            call hf1(42,njdet+.5,weight)
         elseif( IDPRUP.eq.102 ) then
            call hf1(43,njdet+.5,weight)
         endif
         if( njdet.gt.njdmax ) njdet= njdmax

         if( njdet.gt.0 ) then
            do iord=1,njdet
               i= ipjord(iord)
               call pteta( pjets(1,i), pt, eta )
               dr= delta_r( plep, pjets(1,i) )
               call hf1(44,real(pt),weight)
               call hf1(45,real(eta),weight)
               call hf1(46,real(dr),weight)
               am2= pjets(4,i)**2 -pjets(3,i)**2 
     >              -pjets(2,i)**2 -pjets(1,i)**2
               am= 0.d0
               if( am2.gt.0.d0 ) am= sqrt( am2 )
               call hf1(47,real(am),weight)
               if( iord.eq.1 ) then
                  call hf1(50,real(pt),weight)
                  call hf1(51,real(eta),weight)
                  if( IDPRUP.eq.100 ) then
                     call hf1(52,real(pt),weight)
                  elseif( IDPRUP.eq.101 ) then
                     call hf1(53,real(pt),weight)
                  elseif( IDPRUP.eq.102 ) then
                     call hf1(54,real(pt),weight)
                  endif
               elseif( iord.eq.2 ) then
                  call hf1(60,real(pt),weight)
                  call hf1(61,real(eta),weight)
                  if( IDPRUP.eq.100 ) then
                     call hf1(62,real(pt),weight)
                  elseif( IDPRUP.eq.101 ) then
                     call hf1(63,real(pt),weight)
                  elseif( IDPRUP.eq.102 ) then
                     call hf1(64,real(pt),weight)
                  endif
               elseif( iord.eq.3 ) then
                  call hf1(70,real(pt),weight)
                  call hf1(71,real(eta),weight)
                  if( IDPRUP.eq.100 ) then
                     call hf1(72,real(pt),weight)
                  elseif( IDPRUP.eq.101 ) then
                     call hf1(73,real(pt),weight)
                  elseif( IDPRUP.eq.102 ) then
                     call hf1(74,real(pt),weight)
                  endif
               endif
            enddo
         endif

         call hf1(80,real(ptvec),weight)
         call hf1(81,real(rapvec),weight)
         if( IDPRUP.eq.100 ) then
            call hf1(82,real(ptvec),weight)
         elseif( IDPRUP.eq.101 ) then
            call hf1(83,real(ptvec),weight)
         elseif( IDPRUP.eq.102 ) then
            call hf1(84,real(ptvec),weight)
         endif

C  Output the result.
         if( lunres.gt.0 ) then
            if( weight.gt.0. ) then
               evrespos= evrespos +1.d0
            else
               evresneg= evresneg +1.d0
            endif
            write(lunres) IDPRUP,weight,njdet,idlep,ptneu
            write(lunres) plep
            write(lunres) pneu
            if( njdet.ge.1 ) then
               do iord=1,njdet
                  ip= ipjord(iord)
                  write(lunres) ( pjets(i,ip),i=1,4 )
               enddo
            endif
         endif

C...End of loop over events.
 9       continue
      ENDDO

 9000 continue
      if( lunres.gt.0 ) close(lunres)

C...Cross section table.
      CALL PYSTAT(1)

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evtot )
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabs*evdif/evtot
      xerr= xabs * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'The error does not include the error from BASES/SPRING.'
      print *,'-----------------------------'
      evrestot= evrespos +evresneg
      print '(F10.0,'' events in the result file'')', evrestot
      eff= evrestot/evtot
      efferr= sqrt( ( 1.d0 -eff )*eff/evrestot )
      print '('' efficiency = '',F8.5,'' +- '',F8.5)',eff,efferr
      xabsres= xabs*eff
      print '('' -> corresponding abs. xsec = '',E12.6,'' pb'')',xabsres
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evrespos,evresneg
      evresdif= evrespos -evresneg
      rneg= evresneg/evrestot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evrestot )
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabsres*evresdif/evrestot
      xerr= xabsres * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'-----------------------------'

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      subroutine pteta( p, pt, eta )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p(3)

      pt2= p(1)**2 +p(2)**2
      pabs= sqrt( pt2 +p(3)**2 )
      pt= sqrt( pt2 )
      eta= log( ( pabs +abs( p(3) ) )/pt )
      if( p(3).lt.0.d0 ) eta= -eta

      return
      end

      real*8 function delta_r( p1, p2 )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p1(4),p2(4)

      call pteta( p1, pt1, eta1 )
      call pteta( p2, pt2, eta2 )
      csphi= ( p1(1)*p2(1) +p1(2)*p2(2) )/pt1/pt2
      if( csphi.gt.1.d0 ) csphi= 1.d0
      if( csphi.lt.-1.d0 ) csphi= -1.d0
      dphi= acos( csphi )
      delta_r= sqrt( dphi**2 +( eta1 -eta2 )**2 )

      return
      end

      SUBROUTINE UPINIT
C  An "LhaExt" version of UPINIT.
C
C  Initialization for the event mixing.
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      integer nfiles,lunin,ifmt
      double precision sumxsec
      common /lhamulti/sumxsec,nfiles,lunin(10),ifmt(10)
      character*80 filein(10)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      print *,' '
      print *,'============================== UPINIT =====',
     >     '=================================='

      nfiles= 3
      lunin(1)= 11
      ifmt(1)= 0
      filein(1)= '../w0j/lhaext_asc.dat'
      lunin(2)= 12
      ifmt(2)= 0
      filein(2)= '../w1j/lhaext_asc.dat'
      lunin(3)= 13
      ifmt(3)= 0
      filein(3)= '../w2j/lhaext_asc.dat'

      sumxsec= 0.d0
      do ifile=1,nfiles
         if( ifile.eq.1 ) then
            mode= 0
         else
            mode= 2
         endif
         if( ifmt(ifile).eq.0 ) then
            open(lunin(ifile),file=filein(ifile),form='FORMATTED',
     >           status='OLD')
            call lhaReadHdAsc( lunin(ifile), mode )
         elseif( ifmt(ifile).eq.1 ) then
            open(lunin(ifile),file=filein(ifile),form='UNFORMATTED',
     >           status='OLD')
            call lhaReadHdBin( lunin(ifile), mode )
         endif
         sumxsec= sumxsec +XSECUP(ifile)
      enddo

      call RUPdump

      print *,'===========================================',
     >     '=================================='

      return
      end

      SUBROUTINE UPEVNT
C  An "LhaExt" version of UPEVNT.
C
C  This routine reads one event from multiple data files to mix the 
C  events of different processes.
C  The read action is directly done without calling "lhaReadEvnt".
C  The end-of-data of the input is signaled to the calling routine by
C  setting NUP = 0.
C
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      integer nfiles,lunin,ifmt
      double precision sumxsec
      common /lhamulti/sumxsec,nfiles,lunin(10),ifmt(10)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C  Process selection.
      cran= pyr(idummy)*sumxsec
      do iproc=1,NPRUP
         cran= cran -XSECUP(iproc)
         if( cran.le.0.d0 ) goto 1
      enddo
      iproc= NPRUP

 1    continue
      IDPRUP= LPRUP(iproc)

C  Read an event record.
      ifile= iproc
      if( ifmt(ifile).eq.0 ) then
         call lhaReadEvAsc( lunin(ifile), *9 )
      elseif( ifmt(ifile).eq.1 ) then
         call lhaReadEvBin( lunin(ifile), *9 )
      endif

      return

C  No more file to read.
 9    continue
      print '('' EOF reached, file#'',I3)',ifile
      NUP= 0
      return

      END
