      PROGRAM resana
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

      character*80 resfile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

      parameter( njmax= 100 )
      double precision plep(4),pneu(4),pjets(4,njmax)

      dimension evjincp(0:4),evjincn(0:4)
      dimension ptjbinmx1(0:10),evptj1p(10,4),evptj1n(10,4)
      data ptjbinmx1/ 30., 40., 50., 70., 90., 120., 155., 195., 235., 
     >     280., 330. /
      dimension ptjbinmx2(0:7),evptj2p(7,2:4),evptj2n(7,2:4)
      data ptjbinmx2/ 30., 40., 50., 70., 90., 120., 155., 195. /
      dimension ptjbinmx3(0:6),evptj3p(6,3:4),evptj3n(6,3:4)
      data ptjbinmx3/ 30., 40., 50., 70., 90., 120., 155. /
      dimension ptjbinmx4(0:4),evptj4p(4),evptj4n(4)
      data ptjbinmx4/ 30., 40., 50., 70., 90. /
      dimension ptsbinmx(0:13),evptsp(13,4),evptsn(13,4)
      data ptsbinmx/ 75., 105., 135., 165., 200., 240., 280., 330., 
     >     380., 440., 500., 560., 630., 710. /
      dimension amjbinmx(0:13),evamjp(13,2:4),evamjn(13,2:4)
      data amjbinmx/ 75., 105., 135., 165., 200., 240., 280., 330., 
     >     380., 440., 500., 560., 630., 710. /
      parameter ( nbetaj1= 22, etaj1mn= -4.4d0, etaj1mx= 4.4d0 )
      dimension evetaj1p(nbetaj1),evetaj1n(nbetaj1)
      parameter( nbdetalj1= 54, detalj1mn= -5.4d0, detalj1mx= 5.4d0 )
      dimension evdetalj1p(nbdetalj1),evdetalj1n(nbdetalj1)
      parameter( nbsetalj1= 60,setalj1mn= -6.d0, setalj1mx= 6.d0 )
      dimension evsetalj1p(nbsetalj1),evsetalj1n(nbsetalj1)
      parameter( nbdrjj12= 28, drjj12mn= 0.4d0, drjj12mx= 6.0d0 )
      dimension evdrjj12p(nbdrjj12),evdrjj12n(nbdrjj12)
      parameter( nbdeta12= 30, deta12mn= -6.d0, deta12mx= 6.d0 )
      dimension evdeta12p(nbdeta12),evdeta12n(nbdeta12)
      parameter( nbdphi12= 16, dphi12mn= 0.d0, dphi12mx= 3.1415926d0 )
      dimension evdphi12p(nbdphi12),evdphi12n(nbdphi12)

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events. 
C-----------------------------------------------------------------------
      NEV = 9999999                 ! Number of events
C      NEV = 10000

C  Absolute cross section (pb) for the recorded events.
      xabs= 0.525798E+04

C  Open the result file.
      lunres= 10
      resfile= '../result.dat'
      open(lunres,file=resfile,form='UNFORMATTED',status='OLD')

C...Book histograms.
      call hlimit(lhcom)

      call hbook1(1,'pt of lepton$',100,0.,100.,0.)
      call hbook1(2,'eta of lepton$',100,-10.,10.,0.)
      call hbook1(3,'pt of l+$',100,0.,100.,0.)
      call hbook1(4,'eta of l+$',100,-10.,10.,0.)
      call hbook1(5,'pt of l-$',100,0.,100.,0.)
      call hbook1(6,'eta of l-$',100,-10.,10.,0.)
      call hbook1(7,'pt of neutrino$',100,0.,100.,0.)
      call hbook1(8,'mt (GeV)$',100,0.,200.,0.)

      call hbook1(10,'num. of detected jets$',50,0.,50.,0.)
      call hbook1(11,'num. of detected jets (0-jet)$',50,0.,50.,0.)
      call hbook1(12,'num. of detected jets (1-jet)$',50,0.,50.,0.)
      call hbook1(13,'num. of detected jets (2-jet)$',50,0.,50.,0.)
      call hbook1(14,'pt of detected jet (GeV)$',100,0.,500.,0.)
      call hbook1(15,'eta of detected jet$',100,-5.,5.,0.)
      call hbook1(16,'Delta-R of detected jet to lep$',100,0.,5.,0.)
      call hbook1(17,'mass of detected jets$',100,0.,50.,0.)

      call hbook1(20,'pt of 1st jet (GeV)$',50,0.,500.,0.)
      call hbook1(21,'eta of 1st jet$',20,-5.,5.,0.)
      call hbook1(22,'pt of 2nd jet (GeV)$',50,0.,500.,0.)
      call hbook1(23,'eta of 2nd jet$',20,-5.,5.,0.)
      call hbook1(24,'pt of 3rd jet (GeV)$',50,0.,500.,0.)
      call hbook1(25,'eta of 3rd jet$',20,-5.,5.,0.)
      call hbook1(26,'pt of 4th jet (GeV)$',50,0.,500.,0.)
      call hbook1(27,'eta of 4th jet$',20,-5.,5.,0.)

      call hbook1(30,'pt scalar sum (Ht)$',100,0.,1000.,0.)
      call hbook1(31,'inv. mass of leading 2 jets$',100,0.,1000.,0.)
      call hbook1(32,'inv. mass of leading 3 jets$',100,0.,1000.,0.)
      call hbook1(33,'inv. mass of leading 4 jets$',100,0.,1000.,0.)
      call hbook1(34,'eta(lep)-eta(1st jet)$',50,-5.,5.,0.)
      call hbook1(35,'eta(lep)+eta(1st jet)$',50,-10.,10.,0.)
      call hbook1(36,'DR btw. 1st and 2nd jets$',50,0.,10.,0.)
      call hbook1(37,'eta(1st jet)-eta(2nd jet)$',50,-10.,10.,0.)
      call hbook1(38,'Dphi btw. 1st and 2nd jets$',16,0.,3.141593,0.)

      call hbook1(40,'inv. mass of leading 2 jets (w0j)$',
     >     100,0.,1000.,0.)
      call hbook1(41,'inv. mass of leading 2 jets (w1j)$',
     >     100,0.,1000.,0.)
      call hbook1(42,'inv. mass of leading 2 jets (w2j)$',
     >     100,0.,1000.,0.)

      call hbook1(50,'inv. mass of leading 2 jets$',
     >     100,0.,1000.,0.)
      call hbook1(51,'inv. mass of leading 2 jets (w0j)$',
     >     100,0.,1000.,0.)
      call hbook1(52,'inv. mass of leading 2 jets (w1j)$',
     >     100,0.,1000.,0.)
      call hbook1(53,'inv. mass of leading 2 jets (w2j)$',
     >     100,0.,1000.,0.)
C-----------------------------------------------------------------------

      evpos= 0.d0
      evneg= 0.d0

      do i=1,4
         evjincp(i)= 0.d0
         evjincn(i)= 0.d0
      enddo
      do i=1,4
         do ibin=1,10
            evptj1p(ibin,i)= 0.d0
            evptj1n(ibin,i)= 0.d0
         enddo
      enddo
      do i=2,4
         do ibin=1,7
            evptj2p(ibin,i)= 0.d0
            evptj2n(ibin,i)= 0.d0
         enddo
      enddo
      do i=3,4
         do ibin=1,6
            evptj3p(ibin,i)= 0.d0
            evptj3n(ibin,i)= 0.d0
         enddo
      enddo
      do ibin=1,4
         evptj4p(ibin)= 0.d0
         evptj4n(ibin)= 0.d0
      enddo
      do i=1,4
         do ibin=1,13
            evptsp(ibin,i)= 0.d0
            evptsn(ibin,i)= 0.d0
         enddo
      enddo
      do i=2,4
         do ibin=1,13
            evamjp(ibin,i)= 0.d0
            evamjn(ibin,i)= 0.d0
         enddo
      enddo
      do ibin=1,nbetaj1
         evetaj1p(ibin)= 0.d0
         evetaj1n(ibin)= 0.d0
      enddo
      do ibin=1,nbdetalj1
         evdetalj1p(ibin)= 0.d0
         evdetalj1n(ibin)= 0.d0
      enddo
      do ibin=1,nbsetalj1
         evsetalj1p(ibin)= 0.d0
         evsetalj1n(ibin)= 0.d0
      enddo
      do ibin=1,nbdrjj12
         evdrjj12p(ibin)= 0.d0
         evdrjj12n(ibin)= 0.d0
      enddo
      do ibin=1,nbdeta12
         evdeta12p(ibin)= 0.d0
         evdeta12n(ibin)= 0.d0
      enddo
      do ibin=1,nbdphi12
         evdphi12p(ibin)= 0.d0
         evdphi12n(ibin)= 0.d0
      enddo

C...Event loop.
      DO IEV = 1,NEV

C  Read an event.
         read(lunres,end=9000) IDPRUP,weight,njdet,idlep,ptneu
         read(lunres) plep
         read(lunres) pneu
         if( njdet.ge.1 ) then
            do ijet=1,njdet
               read(lunres) ( pjets(i,ijet),i=1,4 )
            enddo
         endif

         if( IEV.le.5 .or. ( IEV.lt.1000 .and. mod(IEV,100).eq.0 )
     >           .or. ( IEV.lt.10000 .and. mod(IEV,1000).eq.0 )
     >           .or. mod(IEV,10000).eq.0 ) then
            print *,''
            print *,'Event# ',IEV
            print '('' process '',I3,'', weight '',F4.1,'', njets '',I3,
     >           '', lepton ID'',I4,'', pt(neutrino) '',F8.2)',
     >           IDPRUP,weight,njdet,idlep,ptneu
            print '(5X,''lepton:   '',4F10.3)', plep
            print '(5X,''neutrino: '',4F10.3)', pneu
            if( njdet.ge.1 ) then
               do ijet=1,njdet
                  print '(5X,''jet'',I3,'': '',4F10.3)', 
     >                 ijet,( pjets(i,ijet),i=1,4 )
               enddo
            endif
         endif

         if( weight.ge.0. ) then
            evpos= evpos +1.d0
         else
            evneg= evneg +1.d0
         endif

C  Leptons.
         call pteta( plep, ptlep, etalep )
         amt2= 2.d0*( ptlep*ptneu
     >        -plep(1)*pneu(1) -plep(2)*pneu(2) )
         amt= 0.d0
         if( amt2.gt.0.d0 ) amt= sqrt( amt2 )
         call hf1(1,real(ptlep),weight)
         call hf1(2,real(etalep),weight)
         if( idlep.lt.0 ) then
            call hf1(3,real(ptlep),weight)
            call hf1(4,real(etalep),weight)
         else
            call hf1(5,real(ptlep),weight)
            call hf1(6,real(etalep),weight)
         endif
         call hf1(7,real(ptneu),weight)
         call hf1(8,real(amt),weight)

C  Additional cut on pt(jet).
         if( njdet.gt.0 ) then
            njacc= 0
            ptpre= 1.d+12
            do i=1,njdet
               call pteta( pjets(1,i), pt, eta )
               if( pt.gt.ptpre ) then
                  print *,'!!! pt-ordering viorated for jets !!!'
                  stop
               endif
               if( pt.ge.30.d0 ) then
                  njacc= njacc +1
               endif
               ptpre= pt
            enddo
            njdet= njacc
         endif

C  Jets.
         call hf1(10,njdet+.5,weight)
         if( IDPRUP.eq.100 ) then
            call hf1(11,njdet+.5,weight)
         elseif( IDPRUP.eq.101 ) then
            call hf1(12,njdet+.5,weight)
         elseif( IDPRUP.eq.102 ) then
            call hf1(13,njdet+.5,weight)
         endif

         if( njdet.gt.0 ) then
            do i=1,njdet
               call pteta( pjets(1,i), pt, eta )
               dr= delta_r( plep, pjets(1,i) )
               call hf1(14,real(pt),weight)
               call hf1(15,real(eta),weight)
               call hf1(16,real(dr),weight)
               am2= pjets(4,i)**2 -pjets(3,i)**2 
     >              -pjets(2,i)**2 -pjets(1,i)**2
               am= 0.d0
               if( am2.gt.0.d0 ) am= sqrt( am2 )
               call hf1(17,real(am),weight)
               if( i.eq.1 ) then
                  call hf1(20,real(pt),weight)
                  call hf1(21,real(eta),weight)
               elseif( i.eq.2 ) then
                  call hf1(22,real(pt),weight)
                  call hf1(23,real(eta),weight)
               elseif( i.eq.3 ) then
                  call hf1(24,real(pt),weight)
                  call hf1(25,real(eta),weight)
               elseif( i.eq.4 ) then
                  call hf1(26,real(pt),weight)
                  call hf1(27,real(eta),weight)
               endif
            enddo
         endif

C  Results.

C  Inclusive jet multiplicity
         do i=0,4
            if( njdet.ge.i ) then
               if( weight.gt.0. ) then
                  evjincp(i)= evjincp(i) +1.d0
               else
                  evjincn(i)= evjincn(i) +1.d0
               endif
            endif
         enddo

C  1st jet pt
         if( njdet.ge.1 ) then
            call pteta( pjets(1,1), pt, eta )
            do ibin=0,10
               if( pt.lt.ptjbinmx1(ibin) ) goto 1
            enddo
            ibin= 11
 1          continue
            if( ibin.ge.1 .and. ibin.le.10 ) then
               if( weight.gt.0. ) then
                  evptj1p(ibin,1)= evptj1p(ibin,1) +1.d0
                  if( njdet.ge.2 ) evptj1p(ibin,2)= evptj1p(ibin,2)+1.d0
                  if( njdet.ge.3 ) evptj1p(ibin,3)= evptj1p(ibin,3)+1.d0
                  if( njdet.ge.4 ) evptj1p(ibin,4)= evptj1p(ibin,4)+1.d0
               else
                  evptj1n(ibin,1)= evptj1n(ibin,1) +1.d0
                  if( njdet.ge.2 ) evptj1n(ibin,2)= evptj1n(ibin,2)+1.d0
                  if( njdet.ge.3 ) evptj1n(ibin,3)= evptj1n(ibin,3)+1.d0
                  if( njdet.ge.4 ) evptj1n(ibin,4)= evptj1n(ibin,4)+1.d0
               endif
            endif
         endif

C  2nd jet pt
         if( njdet.ge.2 ) then
            call pteta( pjets(1,2), pt, eta )
            do ibin=0,7
               if( pt.lt.ptjbinmx2(ibin) ) goto 2
            enddo
            ibin= 8
 2          continue
            if( ibin.ge.1 .and. ibin.le.7 ) then
               if( weight.gt.0. ) then
                  evptj2p(ibin,2)= evptj2p(ibin,2) +1.d0
                  if( njdet.ge.3 ) evptj2p(ibin,3)= evptj2p(ibin,3)+1.d0
                  if( njdet.ge.4 ) evptj2p(ibin,4)= evptj2p(ibin,4)+1.d0
               else
                  evptj2n(ibin,2)= evptj2n(ibin,2) +1.d0
                  if( njdet.ge.3 ) evptj2n(ibin,3)= evptj2n(ibin,3)+1.d0
                  if( njdet.ge.4 ) evptj2n(ibin,4)= evptj2n(ibin,4)+1.d0
               endif
            endif
         endif

C  3rd jet pt
         if( njdet.ge.3 ) then
            call pteta( pjets(1,3), pt, eta )
            do ibin=0,6
               if( pt.lt.ptjbinmx3(ibin) ) goto 3
            enddo
            ibin= 7
 3          continue
            if( ibin.ge.1 .and. ibin.le.6 ) then
               if( weight.gt.0. ) then
                  evptj3p(ibin,3)= evptj3p(ibin,3) +1.d0
                  if( njdet.ge.4 ) evptj3p(ibin,4)= evptj3p(ibin,4)+1.d0
               else
                  evptj3n(ibin,3)= evptj3n(ibin,3) +1.d0
                  if( njdet.ge.4 ) evptj3n(ibin,4)= evptj3n(ibin,4)+1.d0
               endif
            endif
         endif

C  4th jet pt
         if( njdet.ge.4 ) then
            call pteta( pjets(1,4), pt, eta )
            do ibin=0,4
               if( pt.lt.ptjbinmx4(ibin) ) goto 4
            enddo
            ibin= 5
 4          continue
            if( ibin.ge.1 .and. ibin.le.4 ) then
               if( weight.gt.0. ) then
                  evptj4p(ibin)= evptj4p(ibin) +1.d0
               else
                  evptj4n(ibin)= evptj4n(ibin) +1.d0
               endif
            endif
         endif

C  pt scalar sum (Ht)
         if( njdet.ge.1 ) then
            ptsum= ptlep +ptneu
            do i=1,njdet
               call pteta( pjets(1,i), pt, eta )
               ptsum= ptsum +pt
            enddo
            call hf1(30,real(ptsum),weight)
            do ibin=0,13
               if( ptsum.lt.ptsbinmx(ibin) ) goto 5
            enddo
            ibin= 14
 5          continue
            if( ibin.ge.1 .and. ibin.le.13 ) then
               if( weight.gt.0. ) then
                  evptsp(ibin,1)= evptsp(ibin,1) +1.d0
                  if( njdet.ge.2 ) evptsp(ibin,2)= evptsp(ibin,2) +1.d0
                  if( njdet.ge.3 ) evptsp(ibin,3)= evptsp(ibin,3) +1.d0
                  if( njdet.ge.4 ) evptsp(ibin,4)= evptsp(ibin,4) +1.d0
               else
                  evptsn(ibin,1)= evptsn(ibin,1) +1.d0
                  if( njdet.ge.2 ) evptsn(ibin,2)= evptsn(ibin,2) +1.d0
                  if( njdet.ge.3 ) evptsn(ibin,3)= evptsn(ibin,3) +1.d0
                  if( njdet.ge.4 ) evptsn(ibin,4)= evptsn(ibin,4) +1.d0
               endif
            endif
         endif

C  Invariant mass of jets
         if( njdet.ge.2 ) then
            pjet1= sqrt( pjets(1,1)**2 +pjets(2,1)**2 +pjets(3,1)**2 )
            pjet2= sqrt( pjets(1,2)**2 +pjets(2,2)**2 +pjets(3,2)**2 )
            amjets= ( pjet1 +pjet2 )**2
     >           -( pjets(3,1) +pjets(3,2) )**2
     >           -( pjets(2,1) +pjets(2,2) )**2
     >           -( pjets(1,1) +pjets(1,2) )**2
            if( amjets.lt.0.d0 ) amjets= 0.d0
            amjets= sqrt( amjets )
            call hf1(31,real(amjets),weight)
            if( IDPRUP.eq.100 ) then
               call hf1(40,real(amjets),weight)
            elseif( IDPRUP.eq.101 ) then
               call hf1(41,real(amjets),weight)
            elseif( IDPRUP.eq.102 ) then
               call hf1(42,real(amjets),weight)
            endif
            amj12= amjets
            do ibin=0,13
               if( amjets.lt.amjbinmx(ibin) ) goto 6
            enddo
            ibin= 14
 6          continue
            if( ibin.ge.1 .and. ibin.le.13 ) then
               if( weight.gt.0. ) then
                  evamjp(ibin,2)= evamjp(ibin,2) +1.d0
               else
                  evamjn(ibin,2)= evamjn(ibin,2) +1.d0
               endif
            endif
         endif
         if( njdet.ge.3 ) then
            pjet3= sqrt( pjets(1,3)**2 +pjets(2,3)**2 +pjets(3,3)**2 )
            amjets= ( pjet1 +pjet2 +pjet3 )**2
     >           -( pjets(3,1) +pjets(3,2) +pjets(3,3) )**2
     >           -( pjets(2,1) +pjets(2,2) +pjets(2,3) )**2
     >           -( pjets(1,1) +pjets(1,2) +pjets(1,3) )**2
            if( amjets.lt.0.d0 ) amjets= 0.d0
            amjets= sqrt( amjets )
            call hf1(32,real(amjets),weight)
            do ibin=0,13
               if( amjets.lt.amjbinmx(ibin) ) goto 7
            enddo
            ibin= 14
 7          continue
            if( ibin.ge.1 .and. ibin.le.13 ) then
               if( weight.gt.0. ) then
                  evamjp(ibin,3)= evamjp(ibin,3) +1.d0
               else
                  evamjn(ibin,3)= evamjn(ibin,3) +1.d0
               endif
            endif
         endif
         if( njdet.ge.4 ) then
            pjet4= sqrt( pjets(1,4)**2 +pjets(2,4)**2 +pjets(3,4)**2 )
            amjets= ( pjet1 +pjet2 +pjet3 +pjet4 )**2
     >           -( pjets(3,1) +pjets(3,2) +pjets(3,3) +pjets(3,4) )**2
     >           -( pjets(2,1) +pjets(2,2) +pjets(2,3) +pjets(2,4) )**2
     >           -( pjets(1,1) +pjets(1,2) +pjets(1,3) +pjets(1,4) )**2
            if( amjets.lt.0.d0 ) amjets= 0.d0
            amjets= sqrt( amjets )
            call hf1(33,real(amjets),weight)
            do ibin=0,13
               if( amjets.lt.amjbinmx(ibin) ) goto 8
            enddo
            ibin= 14
 8          continue
            if( ibin.ge.1 .and. ibin.le.13 ) then
               if( weight.gt.0. ) then
                  evamjp(ibin,4)= evamjp(ibin,4) +1.d0
               else
                  evamjn(ibin,4)= evamjn(ibin,4) +1.d0
               endif
            endif
         endif

C  eta of the 1st jet
         if( njdet.ge.1 ) then
            call pteta( pjets(1,1), pt, eta )
            width= ( etaj1mx -etaj1mn )/nbetaj1
            ibin= ( eta -etaj1mn )/width +1.d0
            if( ibin.ge.1 .and. ibin.le.nbetaj1 ) then
               if( weight.gt.0. ) then
                  evetaj1p(ibin)= evetaj1p(ibin) +1.d0
               else
                  evetaj1n(ibin)= evetaj1n(ibin) +1.d0
               endif
            endif
         endif

C  eta(lepton) - eta(1st jet)
         if( njdet.ge.1 ) then
            call pteta( pjets(1,1), pt, eta )
            deta= etalep -eta
            call hf1(34,real(deta),weight)
            width= ( detalj1mx -detalj1mn )/nbdetalj1
            ibin= ( deta -detalj1mn )/width +1.d0
            if( ibin.ge.1 .and. ibin.le.nbdetalj1 ) then
               if( weight.gt.0. ) then
                  evdetalj1p(ibin)= evdetalj1p(ibin) +1.d0
               else
                  evdetalj1n(ibin)= evdetalj1n(ibin) +1.d0
               endif
            endif
         endif

C  eta(lepton) + eta(1st jet)
         if( njdet.ge.1 ) then
            call pteta( pjets(1,1), pt, eta )
            sumeta= etalep +eta
            call hf1(35,real(sumeta),weight)
            width= ( setalj1mx -setalj1mn )/nbsetalj1
            ibin= ( sumeta -setalj1mn )/width +1.d0
            if( ibin.ge.1 .and. ibin.le.nbsetalj1 ) then
               if( weight.gt.0. ) then
                  evsetalj1p(ibin)= evsetalj1p(ibin) +1.d0
               else
                  evsetalj1n(ibin)= evsetalj1n(ibin) +1.d0
               endif
            endif
         endif

C  DR between 1st and 2nd jets
         if( njdet.ge.2 ) then
            drjj12= delta_r( pjets(1,1), pjets(1,2) )
            call hf1(36,real(drjj12),weight)
            width= ( drjj12mx -drjj12mn )/nbdrjj12
            ibin= ( drjj12 -drjj12mn )/width +1.d0
            if( ibin.ge.1 .and. ibin.le.nbdrjj12 ) then
               if( weight.gt.0. ) then
                  evdrjj12p(ibin)= evdrjj12p(ibin) +1.d0
               else
                  evdrjj12n(ibin)= evdrjj12n(ibin) +1.d0
               endif
            endif
C  Enhance FSR
            if( abs( drjj12 ).lt.1.d0 ) then
               call hf1(50,real(amj12),weight)
               if( IDPRUP.eq.100 ) then
                  call hf1(51,real(amj12),weight)
               elseif( IDPRUP.eq.101 ) then
                  call hf1(52,real(amj12),weight)
               elseif( IDPRUP.eq.102 ) then
                  call hf1(53,real(amj12),weight)
               endif
            endif
         endif

C  eta(1st jet) - eta(2nd jet)
         if( njdet.ge.2 ) then
            call pteta( pjets(1,1), pt1, eta1 )
            call pteta( pjets(1,2), pt2, eta2 )
            deta12= eta1 -eta2
            call hf1(37,real(deta12),weight)
            width= ( deta12mx -deta12mn )/nbdeta12
            ibin= ( deta12 -deta12mn )/width +1.d0
            if( ibin.ge.1 .and. ibin.le.nbdeta12 ) then
               if( weight.gt.0. ) then
                  evdeta12p(ibin)= evdeta12p(ibin) +1.d0
               else
                  evdeta12n(ibin)= evdeta12n(ibin) +1.d0
               endif
            endif
         endif

C  delta_phi between 1st and 2nd jets
         if( njdet.ge.2 ) then
            pt1= sqrt( pjets(1,1)**2 +pjets(2,1)**2 )
            pt2= sqrt( pjets(1,2)**2 +pjets(2,2)**2 )
            csphi= ( pjets(1,1)*pjets(1,2) +pjets(2,1)*pjets(2,2) )
     >           /pt1/pt2
            dphi12= acos( csphi )
            call hf1(38,real(dphi12),weight)
            width= ( dphi12mx -dphi12mn )/nbdphi12
            ibin= ( dphi12 -dphi12mn )/width +1.d0
            if( ibin.ge.1 .and. ibin.le.nbdphi12 ) then
               if( weight.gt.0. ) then
                  evdphi12p(ibin)= evdphi12p(ibin) +1.d0
               else
                  evdphi12n(ibin)= evdphi12n(ibin) +1.d0
               endif
            endif
         endif

C...End of loop over events.
 9       continue
      ENDDO

 9000 continue
      if( lunres.gt.0 ) close(lunres)

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evtot )
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabs*evdif/evtot
      xerr= xabs * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'-----------------------------'
      print *,'Inclusive jet multiplicity'
      print *,'>=n_jet, positive, negative'
      do i=0,4
         print '(I5,2F10.0)', i,evjincp(i),evjincn(i)
      enddo
      print *,'-----------------------------'
      print *,'1st jet pt'
      print *,'pt range, positive, negative'
      print *,'n_jet >= 1'
      do i=1,10
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx1(i-1),ptjbinmx1(i),evptj1p(i,1),evptj1n(i,1)
      enddo
      print *,'n_jet >= 2'
      do i=1,10
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx1(i-1),ptjbinmx1(i),evptj1p(i,2),evptj1n(i,2)
      enddo
      print *,'n_jet >= 3'
      do i=1,10
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx1(i-1),ptjbinmx1(i),evptj1p(i,3),evptj1n(i,3)
      enddo
      print *,'n_jet >= 4'
      do i=1,10
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx1(i-1),ptjbinmx1(i),evptj1p(i,4),evptj1n(i,4)
      enddo
      print *,'-----------------------------'
      print *,'2nd jet pt'
      print *,'pt range, positive, negative'
      print *,'n_jet >= 2'
      do i=1,7
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx2(i-1),ptjbinmx2(i),evptj2p(i,2),evptj2n(i,2)
      enddo
      print *,'n_jet >= 3'
      do i=1,7
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx2(i-1),ptjbinmx2(i),evptj2p(i,3),evptj2n(i,3)
      enddo
      print *,'n_jet >= 4'
      do i=1,7
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx2(i-1),ptjbinmx2(i),evptj2p(i,4),evptj2n(i,4)
      enddo
      print *,'-----------------------------'
      print *,'3rd jet pt'
      print *,'pt range, positive, negative'
      print *,'n_jet >= 3'
      do i=1,6
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx3(i-1),ptjbinmx3(i),evptj3p(i,3),evptj3n(i,3)
      enddo
      print *,'n_jet >= 4'
      do i=1,6
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx3(i-1),ptjbinmx3(i),evptj3p(i,4),evptj3n(i,4)
      enddo
      print *,'-----------------------------'
      print *,'4th jet pt'
      print *,'pt range, positive, negative'
      print *,'n_jet >= 4'
      do i=1,4
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptjbinmx4(i-1),ptjbinmx4(i),evptj4p(i),evptj4n(i)
      enddo
      print *,'-----------------------------'
      print *,'pt scalar sum (Ht)'
      print *,'Ht range, positive, negative'
      print *,'n_jet >= 1'
      do i=1,13
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptsbinmx(i-1),ptsbinmx(i),evptsp(i,1),evptsn(i,1)
      enddo
      print *,'n_jet >= 2'
      do i=1,13
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptsbinmx(i-1),ptsbinmx(i),evptsp(i,2),evptsn(i,2)
      enddo
      print *,'n_jet >= 3'
      do i=1,13
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptsbinmx(i-1),ptsbinmx(i),evptsp(i,3),evptsn(i,3)
      enddo
      print *,'n_jet >= 4'
      do i=1,13
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        ptsbinmx(i-1),ptsbinmx(i),evptsp(i,4),evptsn(i,4)
      enddo
      print *,'-----------------------------'
      print *,'Invariant mass between jets'
      print *,'mass range, positive, negative'
      print *,'leading 2 jets'
      do i=1,13
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        amjbinmx(i-1),amjbinmx(i),evamjp(i,2),evamjn(i,2)
      enddo
      print *,'leading 3 jets'
      do i=1,13
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        amjbinmx(i-1),amjbinmx(i),evamjp(i,3),evamjn(i,3)
      enddo
      print *,'leading 4 jets'
      do i=1,13
         print '(F4.0,''-'',F4.0,2F10.0)', 
     >        amjbinmx(i-1),amjbinmx(i),evamjp(i,4),evamjn(i,4)
      enddo
      print *,'-----------------------------'
      print *,'Eta of the 1st jet'
      print *,'eta range, positive, negative'
      width= ( etaj1mx -etaj1mn )/nbetaj1
      xbmn= etaj1mn
      do i=1,nbetaj1
         xbmx= xbmn +width
         print '(F5.1,''-'',F5.1,2F10.0)', 
     >        xbmn,xbmx,evetaj1p(i),evetaj1n(i)
         xbmn= xbmx
      enddo
      print *,'-----------------------------'
      print *,'eta(lepton) - eta(1st jet)'
      print *,'deta range, positive, negative'
      width= ( detalj1mx -detalj1mn )/nbdetalj1
      xbmn= detalj1mn
      do i=1,nbdetalj1
         xbmx= xbmn +width
         print '(F5.1,''-'',F5.1,2F10.0)', 
     >        xbmn,xbmx,evdetalj1p(i),evdetalj1n(i)
         xbmn= xbmx
      enddo
      print *,'-----------------------------'
      print *,'eta(lepton) + eta(1st jet)'
      print *,'seta range, positive, negative'
      width= ( setalj1mx -setalj1mn )/nbsetalj1
      xbmn= setalj1mn
      do i=1,nbsetalj1
         xbmx= xbmn +width
         print '(F5.1,''-'',F5.1,2F10.0)', 
     >        xbmn,xbmx,evsetalj1p(i),evsetalj1n(i)
         xbmn= xbmx
      enddo
      print *,'-----------------------------'
      print *,'DR between 1st and 2nd jets'
      print *,'DR range, positive, negative'
      width= ( drjj12mx -drjj12mn )/nbdrjj12
      xbmn= drjj12mn
      do i=1,nbdrjj12
         xbmx= xbmn +width
         print '(F5.1,''-'',F5.1,2F10.0)', 
     >        xbmn,xbmx,evdrjj12p(i),evdrjj12n(i)
         xbmn= xbmx
      enddo
      print *,'-----------------------------'
      print *,'eta(1st jet) - eta(2nd jet)'
      print *,'deta range, positive, negative'
      width= ( deta12mx -deta12mn )/nbdeta12
      xbmn= deta12mn
      do i=1,nbdeta12
         xbmx= xbmn +width
         print '(F5.1,''-'',F5.1,2F10.0)', 
     >        xbmn,xbmx,evdeta12p(i),evdeta12n(i)
         xbmn= xbmx
      enddo
      print *,'-----------------------------'
      print *,'delta_phi between 1st and 2nd jets'
      print *,'dphi range, positive, negative'
      width= ( dphi12mx -dphi12mn )/nbdphi12
      xbmn= dphi12mn
      do i=1,nbdphi12
         xbmx= xbmn +width
         print '(F8.5,''-'',F8.5,2F10.0)', 
     >        xbmn,xbmx,evdphi12p(i),evdphi12n(i)
         xbmn= xbmx
      enddo
      print *,'-----------------------------'

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      subroutine pteta( p, pt, eta )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p(3)

      pt2= p(1)**2 +p(2)**2
      pabs= sqrt( pt2 +p(3)**2 )
      pt= sqrt( pt2 )
      eta= log( ( pabs +abs( p(3) ) )/pt )
      if( p(3).lt.0.d0 ) eta= -eta

      return
      end

      real*8 function delta_r( p1, p2 )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p1(4),p2(4)

      call pteta( p1, pt1, eta1 )
      call pteta( p2, pt2, eta2 )
      csphi= ( p1(1)*p2(1) +p1(2)*p2(2) )/pt1/pt2
      if( csphi.gt.1.d0 ) csphi= 1.d0
      if( csphi.lt.-1.d0 ) csphi= -1.d0
      dphi= acos( csphi )
      delta_r= sqrt( dphi**2 +( eta1 -eta2 )**2 )

      return
      end
