      program grappa
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

      EXTERNAL DRN
      INTEGER IEV,IDUMMY,IGSEC
      DOUBLE PRECISION SUMXSEC,CRAN

C  PSKINI information
      common/PSKfail/ ifail_pskini,nfail_pskini

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

      character*80 lhafile

      parameter ( lhcom = 100000 )
      real*4 h
      common /pawc/h(lhcom)
      character*72 flhist
      real*4 weight

C-----------------------------------------------------------------------
C  Output hbook file; "*" for no output.
C-----------------------------------------------------------------------
C      flhist= '*'
      flhist= 'hist.hbook'
C-----------------------------------------------------------------------
C  Number of events to generate.
C-----------------------------------------------------------------------
C      nevent= 1000
      nevent= 50000
C-----------------------------------------------------------------------
C  Logical unit number for the output event file; 0 for no output.
C-----------------------------------------------------------------------
C      lunwrit= 0
      lunwrit= 20
C-----------------------------------------------------------------------
      if( lunwrit.gt.0 ) then
C  (ASCII file)
         ifmt= 0
         lhafile= 'lhaext_asc.dat'
         open(lunwrit,file=lhafile,form='FORMATTED',status='NEW')
C  (binary file)
C         ifmt= 1
C         lhafile= 'lhaext_bin.dat'
C         open(lunwrit,file=lhafile,form='UNFORMATTED',status='NEW')
      endif
C-----------------------------------------------------------------------
C  Book histograms.
C-----------------------------------------------------------------------
      call hlimit(lhcom)

      call hbook1(1,'Num. of particles$',100,0.,100.,0.)
      call hbook1(2,'Num. of jets$',100,0.,100.,0.)

      call hbook1(10,'mass of V$',100,0.,200.,0.)
      call hbook1(11,'pt of V$',100,0.,200.,0.)
      call hbook1(12,'rapidity of V$',100,-10.,10.,0.)
      call hbook1(13,'pt of V; fine$',100,0.,20.,0.)
      call hbook1(14,'pt of lepton$',100,0.,100.,0.)
      call hbook1(15,'eta of lepton$',100,-10.,10.,0.)
      call hbook1(16,'pt of neutrino$',100,0.,100.,0.)
      call hbook1(17,'mt (GeV)$',100,0.,200.,0.)

      call hbook1(20,'mass of V (pos)$',100,0.,200.,0.)
      call hbook1(21,'pt of V (pos)$',100,0.,200.,0.)
      call hbook1(22,'rapidity of V (pos)$',100,-10.,10.,0.)
      call hbook1(23,'pt of V; fine (pos)$',100,0.,20.,0.)
      call hbook1(24,'pt of lepton (pos)$',100,0.,100.,0.)
      call hbook1(25,'eta of lepton (pos)$',100,-10.,10.,0.)
      call hbook1(26,'pt of neutrino (pos)$',100,0.,100.,0.)
      call hbook1(27,'mt (GeV) (pos)$',100,0.,200.,0.)

      call hbook1(30,'mass of V (neg)$',100,0.,200.,0.)
      call hbook1(31,'pt of V (neg)$',100,0.,200.,0.)
      call hbook1(32,'rapidity of V (neg)$',100,-10.,10.,0.)
      call hbook1(33,'pt of V; fine (neg)$',100,0.,20.,0.)
      call hbook1(34,'pt of lepton (neg)$',100,0.,100.,0.)
      call hbook1(35,'eta of lepton (neg)$',100,-10.,10.,0.)
      call hbook1(36,'pt of neutrino (neg)$',100,0.,100.,0.)
      call hbook1(37,'mt (GeV) (neg)$',100,0.,200.,0.)
C-----------------------------------------------------------------------
C...Initialization.
      CALL UPINIT
      call RUPdump

C  Output the header data.
      if( lunwrit.gt.0 ) then
         if( ifmt.eq.0 ) then
            call lhaWritHdAsc(lunwrit)
         elseif( ifmt.eq.1 ) then
            call lhaWritHdBin(lunwrit)
         endif
      endif

C  Sum of the cross sections.
      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

C...Event loop.
      WRITE(*,'(/10X,''########## Start generating events ##########''
     >     )')

      evpos= 0.d0
      evneg= 0.d0

      DO IEV = 1,nevent

C...Event generation.

C  Process selection.
         CRAN = DRN(IDUMMY)*SUMXSEC
         IGSEC = 0
         DO WHILE (CRAN.GT.0.0D0)
            IGSEC = IGSEC + 1
            CRAN = CRAN - XSECUP(IGSEC)
         ENDDO
         IDPRUP = LPRUP(IGSEC)

C  Generation
         CALL UPEVNT

         if( nevent.le.1000 ) then
            IF (IEV.LE.2 .OR. MOD(IEV,100).EQ.0) THEN
               WRITE(*,*) ' '
               WRITE(*,*) 'Event# ',IEV
               call EUPdump
            ENDIF
         else
            if( iev.le.5 ) then
               WRITE(*,*) ' '
               WRITE(*,*) 'Event# ',IEV
               call EUPdump
            elseif( mod( IEV, 10000 ).eq.0 ) then
               print *,'Event# ',IEV
            endif
         endif

         if( XWGTUP.ge.0.d0 ) then
            weight= 1.
            evpos= evpos +1.d0
         else
            weight= -1.
            evneg= evneg +1.d0
         endif

C  Output the event data.
         if( lunwrit.gt.0 ) then
            if( ifmt.eq.0 ) then
               call lhaWritEvAsc(lunwrit)
            elseif( ifmt.eq.1 ) then
               call lhaWritEvBin(lunwrit)
            endif
         endif

C  Analysis
         ipvec= 0
         iplep= 0
         ipneu= 0
         njet= 0
         do i=1,NUP
            idabs= iabs( IDUP(i) )
            if( idabs.eq.24 ) ipvec= i
            if( idabs.eq.11 .or. idabs.eq.13 ) iplep= i
            if( idabs.eq.12 .or. idabs.eq.14 ) ipneu= i
            if( ISTUP(i).eq.1 .and. 
     >           ( idabs.le.5 .or. idabs.eq.21 ) ) then
               njet= njet +1
            endif
         enddo
         if( ipvec.le.0 ) then
            print *,'??? No vector boson found ???'
            stop
         endif
         call hf1(1,NUP+.5,1.)
         call hf1(2,njet+.5,1.)

C  W
         amvec= PUP(5,ipvec)
         ptvec= sqrt( PUP(1,ipvec)**2 +PUP(2,ipvec)**2 )
         rapvec= log( ( PUP(4,ipvec) +PUP(3,ipvec) )
     >             /( PUP(4,ipvec) -PUP(3,ipvec) ) )/2.d0
         call hf1(10,real(amvec),weight)
         call hf1(11,real(ptvec),weight)
         call hf1(12,real(rapvec),weight)
         call hf1(13,real(ptvec),weight)
         if( weight.gt.0. ) then
            call hf1(20,real(amvec),1.)
            call hf1(21,real(ptvec),1.)
            call hf1(22,real(rapvec),1.)
            call hf1(23,real(ptvec),1.)
         else
            call hf1(30,real(amvec),1.)
            call hf1(31,real(ptvec),1.)
            call hf1(32,real(rapvec),1.)
            call hf1(33,real(ptvec),1.)
         endif

C  Decay leptons
         if( iplep.gt.0 ) then
            il= iplep
            in= ipneu
            idlep= IDUP(il)
            ptlep= sqrt( PUP(1,il)**2 +PUP(2,il)**2 )
            plep= sqrt( PUP(1,il)**2 +PUP(2,il)**2 +PUP(3,il)**2 )
            etalep= log( ( plep +abs( PUP(3,il) ) )/ptlep )
            if( PUP(3,il).lt.0.d0 ) etalep= -etalep
            call hf1(14,real(ptlep),weight)
            call hf1(15,real(etalep),weight)
            ptneu= sqrt( PUP(1,in)**2 +PUP(2,in)**2 )
            amt2= 2.d0*( ptlep*ptneu
     >           -PUP(1,il)*PUP(1,in) -PUP(2,il)*PUP(2,in) )
            amt= 0.d0
            if( amt2.gt.0.d0 ) amt= sqrt( amt2 )
            call hf1(16,real(ptneu),weight)
            call hf1(17,real(amt),weight)
            if( weight.gt.0. ) then
               call hf1(24,real(ptlep),1.)
               call hf1(25,real(etalep),1.)
               call hf1(26,real(ptneu),1.)
               call hf1(27,real(amt),1.)
            else
               call hf1(34,real(ptlep),1.)
               call hf1(35,real(etalep),1.)
               call hf1(36,real(ptneu),1.)
               call hf1(37,real(amt),1.)
            endif
         endif

      ENDDO

      WRITE(*,'(/8X,''########## Event generation completed ##########''
     >     )')
      print *,'Total number of failure returns from PSKINI',
     >     nfail_pskini
      print *,'Do not warry unless too large; e.g., more than 1%.'
      print *,''

C  Summary
      print *,' '
      print *,'---------- Summary ----------'
      xabs= SUMXSEC
      print '('' Integrated absolute cross section = '',E12.6,
     >     '' pb'')', xabs
      print '(F10.0,'' positive, and '',F10.0,
     >     '' negative weight events'')', evpos,evneg
      evtot= evpos +evneg
      evdif= evpos -evneg
      rneg= evneg/evtot
      rnegerr= sqrt( ( 1.d0 -rneg )*rneg/evtot )
      print '(F10.0,'' events in total'')', evtot
      print '('' Negative weight fraction = '',F10.6,'' +- '',F10.6)', 
     >     rneg,rnegerr
      xsec= xabs*evdif/evtot
      xerr= xabs * 2.d0*rnegerr
      print '('' True cross section = '',E12.6,'' +-'',E12.6
     >     '' pb'')', xsec,xerr
      print *,'The error does not include the error from BASES/SPRING.'
      print *,'-----------------------------'

C...Histograms.
      call histdo
C
C -- Store histograms.
C
      if( flhist(1:1).NE.'*' ) then
        call hrput(0,flhist,'N')
      endif

      stop
      END

      subroutine pteta( p, pt, eta )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p(3)

      pt2= p(1)**2 +p(2)**2
      pabs= sqrt( pt2 +p(3)**2 )
      pt= sqrt( pt2 )
      eta= log( ( pabs +abs( p(3) ) )/pt )
      if( p(3).lt.0.d0 ) eta= -eta

      return
      end

      real*8 function delta_r( p1, p2 )
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      real*8 p1(4),p2(4)

      call pteta( p1, pt1, eta1 )
      call pteta( p2, pt2, eta2 )
      csphi= ( p1(1)*p2(1) +p1(2)*p2(2) )/pt1/pt2
      if( csphi.gt.1.d0 ) csphi= 1.d0
      if( csphi.lt.-1.d0 ) csphi= -1.d0
      dphi= acos( csphi )
      delta_r= sqrt( dphi**2 +( eta1 -eta2 )**2 )

      return
      end
